#define _OT4XB_MAP_WAPIST_FUNC_
#include "ot4xb.ch"
#include "CommCtrl_constants.ch"
#include "Appevent.ch"
//----------------------------------------------------------------------------------------------------------------------

// ---------------------------------------------------------------------------
proc dbesys ; return
proc appsys ; return
// ---------------------------------------------------------------------------
proc main
local oDlg,oDa,oLv
SET CHARSET TO ANSI
oDlg := XbpDialog():new(AppDesktop(),,{100,100}, {600,400},,.F.)
oDa  := oDlg:drawingArea
oDa:ClipChildren := .T.
oDlg:taskList := .T.
oDlg:title    := "Testing ListView"
oDlg:close    := {|p1,p2,oo| PostAppEvent(xbeP_Quit,,,oo)}
oDlg:create()


oLv := xbp_listview():New(oDa,,{0,0},oDa:currentSize())
oLv:dwLvStyle := nOr( oLv:dwLvStyle , LVS_SINGLESEL )
oLv:Create()
oLv:lv_SetExtendedListViewStyle( nOr(LVS_EX_FULLROWSELECT,LVS_EX_GRIDLINES))
oLv:lv_SetTextBkColor(0xc8fde3)
oDa:resize := {|p1,p2| oLv:SetSize(p2) }
InitTheListView(oLv)
PopulateTheListView(oLv)
oLv:SetLvNotifyCB( NM_CLICK , {|o,notify_code,lp| OnListViewClick(o,lp) } )


SetAppFocus( oLv )
oLv:Show()
oDlg:Show()
MsgLoop()
return
// ---------------------------------------------------------------------------
static function OnListViewClick(oLv,lp)
local st := NMITEMACTIVATE():New()
st:_link_(lp,.F.)
MsgBox( cPrintf(, "OnListViewClick             "+;
                  "\r\niItem       : %i        "+;
                  "\r\niSubItem    : %i        "+;
                  "\r\nuNewState   : 0x%08.8X  "+;
                  "\r\nuOldState   : 0x%08.8X  "+;
                  "\r\nuChanged    : 0x%08.8X  "+;
                  "\r\nptAction:x  : %i        "+;
                  "\r\nptAction:y  : %i        "+;
                  "\r\nlParam      : %i        "+;
                  "\r\nuKeyFlags   : 0x%i      ",;
                  st:iItem         ,;
                  st:iSubItem      ,;
                  st:uNewState     ,;
                  st:uOldState     ,;
                  st:uChanged      ,;
                  st:ptAction:x    ,;
                  st:ptAction:y    ,;
                  st:lParam        ,;
                  st:uKeyFlags     ))
return NIL // default processing
// ---------------------------------------------------------------------------
static function InitTheListView( oLv )
local n,nn,col
local a := {"Main Column", "Column 1", "Column 2","Column 3","Column 4"}

WITH OBJECT oLv
   col := LVCOLUMN():New()
   .:lv_DeleteAllItems()
   nn := Len(a)
   col:mask := nOr( LVCF_FMT,  LVCF_WIDTH , LVCF_TEXT , LVCF_SUBITEM )
   col:fmt  := LVCFMT_LEFT
   col:cx = 120
   for n := 1 to nn
      col:cText := a[n]
      .:lv_InsertColumn(n-1,col)
   next
   col:cText := NIL
END WITH
return NIL
// ---------------------------------------------------------------------------
static function PopulateTheListView(oLv)
local row,col,item

WITH OBJECT oLv
   item := LVITEM():New()
   .:lv_DeleteAllItems()
   item:mask := LVIF_TEXT
   for row := 0 to 1000
      item:iItem := row
      item:iSubItem := 0
      item:cText := cPrintf("row:%04.4i",row)
      .:lv_InsertItem(item)
      for col := 1 to 4
         item:iSubItem := col
         item:cText := cPrintf("row:%04.4i col:%04.4i",row,col)
         .:lv_SetItem(item)
      next
   next
   item:cText := NIL
END WITH
return NIL

return NIL
// ---------------------------------------------------------------------------
static function MsgLoop()
local nEvt,oo,p1,p2
nEvt := oo := p1 := p2 := NIL
while ( nEvt != xbeP_Quit )
   nEvt := AppEvent(@p1,@p2,@oo )
   oo:HandleEvent(nEvt,p1,p2)
end
return NIL
//----------------------------------------------------------------------------
