#define OT4XB_MIN_VER "001.005.017.009"
#define _OT4XB_MAP_WAPIST_FUNC_
#include "ot4xb.ch"
#include "WinBase_constants.ch"
#include "WinError_constants.ch"
#include "WinUser_constants.ch"
#include "CommCtrl_constants.ch"
//----------------------------------------------------------------------------------------------------------------------
#xtranslate \<<msg>\>(<wp>,<lp>) => FpQCall(_fp_SendMessageA_,"__sl__hw__sl__sl__sl",::hLv,<msg>,<wp>,<lp>)
#xtranslate \<<msg>\>\[<tp>\](<wp>,<lp>) => FpQCall(_fp_SendMessageA_,<tp>,::hLv,<msg>,<wp>,<lp>)
//----------------------------------------------------------------------------------------------------------------------
#xtranslate _assert_m_(<b>,<n>,<cc>) => ;
             if !(<b>) ;
            ;  TlsStackPush(Error():New());
            ;  TlsStackTop():severity := 2;
            ;  TlsStackTop():description := <cc> ;
            ;  TlsStackTop():gencode     := 0    ;
            ;  TlsStackTop():subcode     := <n>  ;
            ;  TlsStackTop():subsystem   := ::ClassName() ;
            ;  TlsStackTop():operation   := ProcName()  ;
            ;  Eval(ErrorBlock(),TlsStackPop()) ;
            ;end
//----------------------------------------------------------------------------------------------------------------------
//----------------------------------------------------------------------------------------------------------------------
static _fp_SendMessageA_ := NIL
//----------------------------------------------------------------------------------------------------------------------

//----------------------------------------------------------------------------------------------------------------------
CLASS xbp_listview FROM XbpStatic
EXPORTED:
       // ---------------------------------------------------------------------------------
       VAR hXbp, hLv
       VAR dwLvStyle,dwLvStyleEx
       VAR m_ht
       // ---------------------------------------------------------------------------------
       // ---------------------------------------------------------------------------------
INLINE CLASS METHOD initclass()
       local e
       if ot4xb() < OT4XB_MIN_VER
          e := Error():New()
          e:severity := 2
          e:description := cPrintf(,"xbp_listview class ot4xb [%s] or higher.\r\n Current is %s", OT4XB_MIN_VER, ot4xb())
          Eval(ErrorBlock(),e)
       end
       @comctl32:InitCommonControlsEx({8,ICC_LISTVIEW_CLASSES})
       _fp_SendMessageA_ := nGetProcAddress("user32","SendMessageA") // user32 will be never relocated
       return Self
       // ---------------------------------------------------------------------------------
INLINE METHOD init(p1,p2,p3,p4,p5,p6)
       ::XbpStatic:init(p1,p2,p3,p4,p5,p6)
       ::dwLvStyle := nOr(WS_TABSTOP,WS_CHILD,WS_BORDER,WS_VISIBLE,LVS_AUTOARRANGE,LVS_REPORT)
       ::dwLvStyleEx := 0
       return Self
       // ---------------------------------------------------------------------------------
INLINE METHOD Create(p1,p2,p3,p4,p5,p6)
       ::clipChildren := .T.
       ::XbpStatic:Create(p1,p2,p3,p4,p5,p6)
       ::hXbp := ::GetHWnd()
       ot4xb_subclasswindow(::hXbp,Self,,"xbp_wndproc")
       @user32:SendMessageA(::hXbp,WM_USER+1,0,0)
       return Self
       // ---------------------------------------------------------------------------------
INLINE METHOD SetLvNotifyCB( notify_code , b )
       local k,r
       local np  := PCount()
       if Valtype(notify_code) != "N" ; return NIL ; end
       k := cPrintf("LV%08.8X.notify",notify_code)
       r := delegated_eval( {|| iif( ::m_ht == NIL,, _hdict_GetProp(::m_ht,k)) } )
       if np > 1
          if Valtype(b) == "B"
             delegated_eval( {|| iif( ::m_ht == NIL,, _hdict_SetProp(::m_ht,k,b)) } )
          else
             delegated_eval( {|| iif( ::m_ht == NIL,, _hdict_RemoveProp(::m_ht,k)) } )
          end
       end
       return r
       // ---------------------------------------------------------------------------------
INLINE METHOD xbp_wndproc(hWnd,nMsg,wp,lp,ctx)
       local rc,n
       if nMsg == (WM_USER + 1 )
          ::m_ht := _hdict_new()
          rc := {0,0,0,0}
          @user32:GetClientRect(hWnd,@rc)
          @user32:SetWindowLongA(hWnd,GWL_EXSTYLE,nOr(@user32:GetWindowLongA(hWnd,GWL_EXSTYLE),WS_EX_CONTROLPARENT))
          ::hLv := @user32:CreateWindowExA(::dwLvStyleEx,WC_LISTVIEW,"",::dwLvStyle,0,0,rc[3],rc[4], hWnd, 1 ,AppInstance(),0)
          return 0
       elseif nMsg == WM_SIZE
          rc := {0,0,0,0}
          @user32:GetClientRect(hWnd,@rc)
          @user32:SetWindowPos(::hLv,0,0,0,rc[3],rc[4],nOr(SWP_NOACTIVATE,SWP_NOCOPYBITS,SWP_NOREPOSITION,SWP_NOSENDCHANGING,SWP_NOZORDER))
          return NIL
       elseif nMsg == WM_ERASEBKGND
          return 1
       elseif nMsg == WM_NOTIFY
          if lp == 0 ; return NIL ; end // must not happen
          if( PeekDWord(lp) == ::hLv )
            return ::_HandleListViewNotify_( PeekDWord(lp,8) , lp )
          end
          return NIL
       elseif nMsg == WM_NCDESTROY
          if ::m_ht != NIL ; _hdict_destroy(::m_ht) ; ::m_ht := NIL ; end
       end
       return NIL
       // ---------------------------------------------------------------------------------
INLINE METHOD _HandleListViewNotify_( notify_code , p ) // do not call outside GUI thread
       local b := iif( ::m_ht==NIL,NIL, _hdict_getprop(::m_ht, cPrintf("LV%08.8X.notify",notify_code)) )
       if Valtype(b) =="B"
          return Eval(b, Self , notify_code , p )
       end
       return NIL
       // ---------------------------------------------------------------------------------
       // ---------------------------------------------------------------------------------
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_SetUnicodeFormat(b)           ; return <LVM_SETUNICODEFORMAT>["__bo__hw__sl__bo__sl"](b,0)
INLINE METHOD lv_GetUnicodeFormat()            ; return <LVM_GETUNICODEFORMAT>["__bo__hw__sl__sl__sl"](0,0)
INLINE METHOD lv_GetBkColor()                  ; return <LVM_GETBKCOLOR>(0,0)
INLINE METHOD lv_SetBkColor(n)                 ; return <LVM_SETBKCOLOR>(0,n)
INLINE METHOD lv_GetImageList(n)               ; return <LVM_GETIMAGELIST>(n,0)
INLINE METHOD lv_SetImageList(h,n)             ; return <LVM_SETIMAGELIST>(h,n)
INLINE METHOD lv_GetItemCount()                ; return <LVM_GETITEMCOUNT>(0,0)
INLINE METHOD lv_GetItem(p)                    ; return <LVM_GETITEM>["__bo__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_SetItem(p)                    ; return <LVM_SETITEM>["__bo__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_InsertItem(p)                 ; return <LVM_INSERTITEM>["__bo__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_DeleteItem(n)                 ; return <LVM_DELETEITEM>(0,n)
INLINE METHOD lv_DeleteAllItems()              ; return <LVM_DELETEALLITEMS>(0,0)
INLINE METHOD lv_GetCallbackMask()             ; return <LVM_GETCALLBACKMASK>(0,0)
INLINE METHOD lv_SetCallbackMask(n)            ; return <LVM_SETCALLBACKMASK>(n,0)
INLINE METHOD lv_GetNextItem(n,flags)          ; return <LVM_GETNEXTITEM>(n,flags)
INLINE METHOD lv_FindItem(n,p)                 ; return <LVM_FINDITEM>["__sl__hw__sl__sl__pt"](n,@p)
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_GetItemRect(n,rc,code)
       DEFAULT rc := AFill(Array(4),0)
       DEFAULT code := 0
       PokeDWord(@rc,0,code)
       return <LVM_GETITEMRECT>["__bo__hw__sl__sl__pt"](n,@rc)
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_SetItemPosition(n,x,y)        ; return <LVM_SETITEMPOSITION>["__bo__hw__sl__sl__sl"](n,MAKELPARAM(x,y))
INLINE METHOD lv_GetItemPosition(n,pt)         ; return <LVM_GETITEMPOSITION>["__bo__hw__sl__sl__pt"](n,@pt)
INLINE METHOD lv_GetStringWidth(c)             ; return <LVM_GETSTRINGWIDTH>["__sl__hw__sl__sl__pt"](0,@c)
INLINE METHOD lv_HitTest(p)                    ; return <LVM_HITTEST>["__sl__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_HitTestEx(p)                  ; return <LVM_HITTEST>["__sl__hw__sl__sl__pt"](-1,@p)
INLINE METHOD lv_EnsureVisible(n,lPartialOk)   ; return <LVM_ENSUREVISIBLE>["__sl__hw__sl__sl__bo"](n,lPartialOk)
INLINE METHOD lv_Scroll(dx,dy)                 ; return <LVM_SCROLL>["__bo__hw__sl__sl__sl"](dx,dy)
INLINE METHOD lv_RedrawItems(nFirst,nLast)     ; return <LVM_REDRAWITEMS>["__bo__hw__sl__sl__sl"](nFirst,nLast)
INLINE METHOD lv_Arrange(code)                 ; return <LVM_ARRANGE>["__bo__hw__sl__sl__sl"](code,0)
INLINE METHOD lv_EditLabel(n)                  ; return <LVM_EDITLABEL>["__hw__hw__sl__sl__sl"](n,0)
INLINE METHOD lv_GetEditControl()              ; return <LVM_GETEDITCONTROL>["__hw__hw__sl__sl__sl"](0,0)
INLINE METHOD lv_GetColumn(n,p)                ; return <LVM_GETCOLUMN>["__bo__hw__sl__sl__pt"](n,@p)
INLINE METHOD lv_SetColumn(n,p)                ; return <LVM_SETCOLUMN>["__bo__hw__sl__sl__pt"](n,@p)
INLINE METHOD lv_InsertColumn(n,p)             ; return <LVM_INSERTCOLUMN>["__sl__hw__sl__sl__pt"](n,@p)
INLINE METHOD lv_DeleteColumn(n)               ; return <LVM_DELETECOLUMN>["__bo__hw__sl__sl__sl"](n,0)
INLINE METHOD lv_GetColumnWidth(n)             ; return <LVM_GETCOLUMNWIDTH>(n,0)
INLINE METHOD lv_SetColumnWidth(n,cx)          ; return <LVM_SETCOLUMNWIDTH>["__bo__hw__sl__sl__sl"](n,cx)
INLINE METHOD lv_GetHeader()                   ; return <LVM_GETHEADER>(0,0)
INLINE METHOD lv_CreateDragImage(n,pt)         ; return <LVM_CREATEDRAGIMAGE>["__sl__hw__sl__sl__pt"](n,@pt)
INLINE METHOD lv_GetViewRect(rc)               ; return <LVM_GETVIEWRECT>["__bo__hw__sl__sl__pt"](0,@rc)
INLINE METHOD lv_GetTextColor()                ; return <LVM_GETTEXTCOLOR>(0,0)
INLINE METHOD lv_SetTextColor(n)               ; return <LVM_SETTEXTCOLOR>["__bo__hw__sl__sl__sl"](0,n)
INLINE METHOD lv_GetTextBkColor()              ; return <LVM_GETTEXTBKCOLOR>(0,0)
INLINE METHOD lv_SetTextBkColor(n)             ; return <LVM_SETTEXTBKCOLOR>["__bo__hw__sl__sl__sl"](0,n)
INLINE METHOD lv_GetTopIndex()                 ; return <LVM_GETTOPINDEX>(0,0)
INLINE METHOD lv_GetCountPerPage()             ; return <LVM_GETCOUNTPERPAGE>(0,0)
INLINE METHOD lv_GetOrigin(pt)                 ; return <LVM_GETORIGIN>["__bo__hw__sl__sl__pt"](0,@pt)
INLINE METHOD lv_Update(n)                     ; return <LVM_UPDATE>["__bo__hw__sl__sl__sl"](n,0)
INLINE METHOD lv_SetItemState(n,d,m)           ; return <LVM_SETITEMSTATE>["__vo__hw__sl__sl__pt"](n,__i32(0,0,0,d,m,0,0,0,0,0,0,0,0,0,0))
INLINE METHOD lv_SetCheckState(n,l)            ; return ::lv_SetItemState(n,nLShift(iif(l,2,1),12),LVIS_STATEIMAGEMASK)
INLINE METHOD lv_GetItemState(n,m)             ; return <LVM_GETITEMSTATE>(n,m)
INLINE METHOD lv_GetCheckState(n)              ; return ( nRShift(<LVM_GETITEMSTATE>(n,LVIS_STATEIMAGEMASK),12) - 1 )
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_GetItemText(n,nSub,cb)  // -> cText
       local item   := AFill(Array(15),0)
       local buffer,cc
       DEFAULT n    := 0
       DEFAULT nSub := 0
       DEFAULT cb   := 1024
       item[6] := buffer := _xgrab(cb)
       item[7] := cb
       cb := <LVM_GETITEMTEXT>["__sl__hw__sl__sl__pt"](n,@item)
       cc := PeekStr(buffer,,cb)
       _xfree(buffer)
       return cc
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_SetItemText(n,nSub,cText)
       local t      := Valtype(cText)
       local item   := AFill(Array(15),0)
       local buffer := NIL
       DEFAULT n    := 0
       DEFAULT nSub := 0
       if( t $ "CM" )
          item[6] := buffer := _xgrab(cText)
       elseif t == "N"
          item[6] := cText
       end
       <LVM_SETITEMTEXT>["__sl__hw__sl__sl__pt"](n,@item)
       if buffer != NIL ;  _xfree(buffer) ; end
       return NIL
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_SetItemCount(n)               ; return <LVM_SETITEMCOUNT>(n,0)
INLINE METHOD lv_SetItemCountEx(n,flags)       ; return <LVM_SETITEMCOUNT>(n,flags)
INLINE METHOD lv_SortItems(fp,ctx)             ; return <LVM_SORTITEMS>["__bo__hw__sl__sl__sl"](ctx,fp)
INLINE METHOD lv_SetItemPosition32(n,x,y)      ; return <LVM_SETITEMPOSITION32>["__bo__hw__sl__sl__pt"](n,__i32(x,y) )
INLINE METHOD lv_GetSelectedCount()            ; return <LVM_GETSELECTEDCOUNT>(0,0)
INLINE METHOD lv_GetItemSpacing(lSmall)        ; return <LVM_GETITEMSPACING>["__sl__hw__sl__bo__sl"](lSmall,0)
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_GetISearchString()
       local cb := <LVM_GETISEARCHSTRING>(0,0)
       local buffer := _xgrab( nOr(cb + 64,255) + 1 )
       local cc
       cb = <LVM_GETISEARCHSTRING>(0,buffer)
       cc := PeekStr(buffer,,cb)
       _xfree(buffer)
       return cc
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_SetIconSpacing(cx,cy)         ; return <LVM_SETICONSPACING>(0,MAKELONG(cx,cy))
INLINE METHOD lv_SetExtendedListViewStyle(dw)  ; return <LVM_SETEXTENDEDLISTVIEWSTYLE>(0,dw)
INLINE METHOD lv_SetExtendedListViewStyleEx(dwMask,dw) ; return <LVM_SETEXTENDEDLISTVIEWSTYLE>(dwMask,dw)
INLINE METHOD lv_GetExtendedListViewStyle()    ; return <LVM_GETEXTENDEDLISTVIEWSTYLE>(0,0)
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_GetSubItemRect(n,nSub,code,rc)
       DEFAULT rc := AFill(Array(4),0)
       DEFAULT code := 0
       DEFAULT nSub := 0
       PokeDWord(@rc,0,code)
       PokeDWord(@rc,0,nSub)
       return <LVM_GETSUBITEMRECT>["__bo__hw__sl__sl__pt"](n,@rc)
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_SubItemHitTest(p)             ; return <LVM_SUBITEMHITTEST>["__sl__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_SubItemHitTestEx(p)           ; return <LVM_SUBITEMHITTEST>["__sl__hw__sl__sl__pt"](-1,@p)
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_SetColumnOrderArray(a)
       _assert_m_( (Valtype(a)=="A"),-1,"Invalid Param")
       return <LVM_SETCOLUMNORDERARRAY>["__bo__hw__sl__sl__pt"](Len(a),a)
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_GetColumnOrderArray(a)        ;AFill(a,0); return <LVM_GETCOLUMNORDERARRAY>["__bo__hw__sl__sl__pt"](Len(a),@a)
INLINE METHOD lv_SetHotItem(n)                 ; return <LVM_SETHOTITEM>(n,0)
INLINE METHOD lv_GetHotItem()                  ; return <LVM_GETHOTITEM>(0,0)
INLINE METHOD lv_SetHotCursor(h)               ; return <LVM_SETHOTCURSOR>(0,h)
INLINE METHOD lv_GetHotCursor()                ; return <LVM_GETHOTCURSOR>(0,0)
INLINE METHOD lv_ApproximateViewRect(cx,cy,n)  ; return <LVM_APPROXIMATEVIEWRECT>(n,MAKELPARAM(cx,cy))
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_SetWorkAreas(lst) // lst :=  { oRect , {left,top,right,bottom} , __i32(left,top,right,bottom) , .... }
       local buffer,nCount,n,p,result
       _assert_m_( (Valtype(lst)=="A"),-1,"Invalid Param")
       nCount := len(lst)
       if nCount > LV_MAX_WORKAREAS ; nCount := LV_MAX_WORKAREAS ; end
       buffer := _xgrab(16 * nCount)
       for n := 1 to nCount
          @ot4xb:_bcopy(p,lst[n],16)
          p += 16
       next
       <LVM_SETWORKAREAS>(nCount,buffer)
       _xfree(buffer)
       return NIL
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_GetWorkAreas() // ->  { {left,top,right,bottom} , ... }
       local nCount := ::lv_GetNumberOfWorkAreas()
       local lst,n,buffer,ns
       if nCount == NIL ; return NIL ; end
       if nCount < 1 ; return Array(0) ; end
       buffer := _xgrab(16 * nCount)
       <LVM_GETWORKAREAS>( nCount,buffer)
       ns := 0
       lst := Array(nCount)
       for n := 1 to nCount
          lst[n] := PeekDWord(buffer,@ns,4)
       next
       _xfree(buffer)
       return lst
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_GetNumberOfWorkAreas()
       local n := 0
       if(<LVM_GETNUMBEROFWORKAREAS>["__bo__hw__sl__sl_@sl"](0,@n))
          return n
       end
       return NIL
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_GetSelectionMark()            ; return <LVM_GETSELECTIONMARK>(0,0)
INLINE METHOD lv_SetSelectionMark(n)           ; return <LVM_SETSELECTIONMARK>(0,n)
INLINE METHOD lv_SetHoverTime(n)               ; return <LVM_SETHOVERTIME>(0,n)
INLINE METHOD lv_GetHoverTime()                ; return <LVM_GETHOVERTIME>(0,0)
INLINE METHOD lv_SetToolTips(hToolTip)         ; return <LVM_SETTOOLTIPS>["__hw__hw__sl__hw__sl"](hToolTip,0)
INLINE METHOD lv_GetToolTips()                 ; return <LVM_GETTOOLTIPS>["__hw__hw__sl__sl__sl"](0,0)
INLINE METHOD lv_SortItemsEx(fp,ctx)           ; return <LVM_SORTITEMSEX>["__bo__hw__sl__sl__sl"](ctx,fp)
INLINE METHOD lv_SetSelectedColumn(n)          ; return <LVM_SETSELECTEDCOLUMN>["__vo__hw__sl__sl__sl"](n,0)
INLINE METHOD lv_SetView(n)                    ; return (<LVM_SETVIEW>(n,0) == 1 )
INLINE METHOD lv_GetView()                     ; return <LVM_GETVIEW>(0,0)
INLINE METHOD lv_InsertGroup(n,p)              ; return <LVM_INSERTGROUP>["__sl__hw__sl__sl__pt"](n,@p)
INLINE METHOD lv_SetGroupInfo(n,p)             ; return <LVM_SETGROUPINFO>["__sl__hw__sl__sl__pt"](n,@p)
INLINE METHOD lv_GetGroupInfo(n,p)             ; return <LVM_GETGROUPINFO>["__sl__hw__sl__sl__pt"](n,@p)
INLINE METHOD lv_RemoveGroup(n)                ; return <LVM_REMOVEGROUP>(n,0)
// INLINE METHOD lv_MoveGroup(n,nn)               ; return <LVM_MOVEGROUP>(n,nn)  // MSDN said not implemented
INLINE METHOD lv_GetGroupCount()               ; return <LVM_GETGROUPCOUNT>(0,0)
INLINE METHOD lv_GetGroupInfoByIndex(n,p)      ; return <LVM_GETGROUPINFOBYINDEX>["__sl__hw__sl__sl__pt"](n,@p)
// INLINE METHOD lv_MoveItemToGroup(n,nn)         ; return <LVM_MOVEITEMTOGROUP>(n,nn) // MSDN said not implemented
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_GetGroupRect(nId,nType,rc)
       DEFAULT rc := AFill(Array(4),0)
       DEFAULT nType := 0
       PokeDWord(@rc,0,nType)
       return <LVM_GETGROUPRECT>["__bo__hw__sl__sl__pt"](nId,@rc)
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_SetGroupMetrics(p)            ; return <LVM_SETGROUPMETRICS>["__vo__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_GetGroupMetrics(p)            ; return <LVM_GETGROUPMETRICS>["__vo__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_EnableGroupView(l)            ; return <LVM_ENABLEGROUPVIEW>["__sl__hw__sl__bo__sl"](l,0)
INLINE METHOD lv_SortGroups(fp,ctx)            ; return <LVM_SORTGROUPS>["__bo__hw__sl__sl__sl"](fp,ctx)
INLINE METHOD lv_InsertGroupSorted(p)          ; return <LVM_INSERTGROUPSORTED>["__vo__hw__sl__pt__sl"](@p,0)
INLINE METHOD lv_RemoveAllGroups()             ; return <LVM_REMOVEALLGROUPS>(0,0)
INLINE METHOD lv_HasGroup(id)                  ; return <LVM_HASGROUP>["__bo__hw__sl__sl__sl"](id,0)
INLINE METHOD lv_SetGroupState(n,m,s)          ; return <LVM_SETGROUPINFO>["__sl__hw__sl__sl__pt"](n,__i32(40,LVGF_STATE,0,0,0,0,0,m,s,0))
INLINE METHOD lv_GetGroupState(n,m)            ; return <LVM_GETGROUPSTATE>(n,m)
INLINE METHOD lv_GetFocusedGroup()             ; return <LVM_GETFOCUSEDGROUP>(0,0)
INLINE METHOD lv_SetTileViewInfo(p)            ; return <LVM_SETTILEVIEWINFO>["__bo__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_GetTileViewInfo(p)            ; return <LVM_GETTILEVIEWINFO>["__vo__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_SetTileInfo(p)                ; return <LVM_SETTILEINFO>["__bo__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_GetTileInfo(p)                ; return <LVM_GETTILEINFO>["__vo__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_SetInsertMark(p)              ; return <LVM_SETINSERTMARK>["__bo__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_GetInsertMark(p)              ; return <LVM_GETINSERTMARK>["__bo__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_InsertMarkHitTest(pt,im)      ; return <LVM_INSERTMARKHITTEST>["__bo__hw__sl__pt__pt"](@pt,@im)
INLINE METHOD lv_GetInsertMarkRect(rc)         ; return <LVM_GETINSERTMARKRECT>["__sl__hw__sl__sl__pt"](0,@rc)
INLINE METHOD lv_SetInsertMarkColor(n)         ; return <LVM_SETINSERTMARKCOLOR>(0,n)
INLINE METHOD lv_GetInsertMarkColor()          ; return <LVM_GETINSERTMARKCOLOR>(0,0)
INLINE METHOD lv_SetInfoTip(p)                 ; return <LVM_SETINFOTIP>["__bo__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_GetSelectedColumn()           ; return <LVM_GETSELECTEDCOLUMN>(0,0)
INLINE METHOD lv_IsGroupViewEnabled()          ; return <LVM_ISGROUPVIEWENABLED>["__bo__hw__sl__sl__sl"](0,0)
INLINE METHOD lv_GetOutlineColor()             ; return <LVM_GETOUTLINECOLOR>(0,0)
INLINE METHOD lv_SetOutlineColor(n)            ; return <LVM_SETOUTLINECOLOR>(0,n)
INLINE METHOD lv_CancelEditLabel()             ; return <LVM_CANCELEDITLABEL>["__vo__hw__sl__sl__sl"](0,0)
INLINE METHOD lv_MapIndexToID(n)               ; return <LVM_MAPINDEXTOID>(n,0)
INLINE METHOD lv_MapIDToIndex(n)               ; return <LVM_MAPIDTOINDEX>(n,0)
INLINE METHOD lv_IsItemVisible(n)              ; return <LVM_ISITEMVISIBLE>["__bo__hw__sl__sl__sl"](n,0)
INLINE METHOD lv_SetGroupHeaderImageList(h)    ; return <LVM_SETIMAGELIST>(LVSIL_GROUPHEADER,h)
INLINE METHOD lv_GetGroupHeaderImageList()     ; return <LVM_GETIMAGELIST>(LVSIL_GROUPHEADER,0)
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_GetEmptyText()
       local cc := ChrR(0,256)
       if <LVM_GETEMPTYTEXT>["__bo__hw__sl__sl__pt"](Len(cc)-2,@cc)
          return cSzWide2Ansi(cc)
       end
       return NIL
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_GetFooterRect(rc)             ; return <LVM_GETFOOTERRECT>["__bo__hw__sl__sl__pt"](0,@rc)
INLINE METHOD lv_GetFooterInfo(p)              ; return <LVM_GETFOOTERINFO>["__bo__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_GetFooterItemRect(n,rc)       ; return <LVM_GETFOOTERITEMRECT>["__bo__hw__sl__sl__pt"](n,@rc)
INLINE METHOD lv_GetFooterItem(n,p)            ; return <LVM_GETFOOTERITEM>["__bo__hw__sl__sl__pt"](n,@p)
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_GetItemIndexRect(p,nSub,code,rc)
       DEFAULT rc := AFill(Array(4),0)
       DEFAULT code := 0
       DEFAULT nSub := 0
       PokeDWord(@rc,0,code)
       PokeDWord(@rc,0,nSub)
       return <LVM_GETITEMINDEXRECT>["__bo__hw__sl__pt__pt"](@p,@rc)
       // ---------------------------------------------------------------------------------
INLINE METHOD lv_SetItemIndexState(p,d,m)      ; return <LVM_SETITEMINDEXSTATE>["__bo__hw__sl__pt__pt"](@p,__i32(0,0,0,d,m,0,0,0,0,0,0,0,0,0,0))
INLINE METHOD lv_GetNextItemIndex(p,dw)        ; return <LVM_GETNEXTITEMINDEX>["__vo__hw__sl__pt__ss"](@p,dw)
INLINE METHOD lv_SetBkImage(p)                 ; return <LVM_SETBKIMAGE>["__bo__hw__sl__sl__pt"](0,@p)
INLINE METHOD lv_GetBkImage(p)                 ; return <LVM_GETBKIMAGE>["__bo__hw__sl__sl__pt"](0,@p)
       // ---------------------------------------------------------------------------------
ENDCLASS
//----------------------------------------------------------------------------------------------------------------------
